package com.controller;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Date;
import java.util.List;
import javax.servlet.http.HttpServletRequest;

import com.utils.ValidatorUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.annotation.IgnoreAuth;

import com.entity.FafangpaizhaoEntity;
import com.entity.view.FafangpaizhaoView;

import com.service.FafangpaizhaoService;
import com.service.TokenService;
import com.utils.PageUtils;
import com.utils.R;
import com.utils.MPUtil;
import com.utils.MapUtils;
import com.utils.CommonUtil;
import java.io.IOException;

/**
 * 发放牌照
 * 后端接口
 * @author 
 * @email 
 * @date 2030-03-20 23:07:15
 */
@RestController
@RequestMapping("/fafangpaizhao")
public class FafangpaizhaoController {
    @Autowired
    private FafangpaizhaoService fafangpaizhaoService;




    



    /**
     * 后端列表
     */
    @RequestMapping("/page")
    public R page(@RequestParam Map<String, Object> params,FafangpaizhaoEntity fafangpaizhao,
		HttpServletRequest request){
		String tableName = request.getSession().getAttribute("tableName").toString();
		if(tableName.equals("jiashiyuan")) {
			fafangpaizhao.setZhanghao((String)request.getSession().getAttribute("username"));
		}
		if(tableName.equals("gongzuorenyuan")) {
			fafangpaizhao.setYuangongzhanghao((String)request.getSession().getAttribute("username"));
		}
        EntityWrapper<FafangpaizhaoEntity> ew = new EntityWrapper<FafangpaizhaoEntity>();

		PageUtils page = fafangpaizhaoService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, fafangpaizhao), params), params));

        return R.ok().put("data", page);
    }
    
    /**
     * 前端列表
     */
	@IgnoreAuth
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params,FafangpaizhaoEntity fafangpaizhao, 
		HttpServletRequest request){
        EntityWrapper<FafangpaizhaoEntity> ew = new EntityWrapper<FafangpaizhaoEntity>();

		PageUtils page = fafangpaizhaoService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, fafangpaizhao), params), params));
        return R.ok().put("data", page);
    }



	/**
     * 列表
     */
    @RequestMapping("/lists")
    public R list( FafangpaizhaoEntity fafangpaizhao){
       	EntityWrapper<FafangpaizhaoEntity> ew = new EntityWrapper<FafangpaizhaoEntity>();
      	ew.allEq(MPUtil.allEQMapPre( fafangpaizhao, "fafangpaizhao")); 
        return R.ok().put("data", fafangpaizhaoService.selectListView(ew));
    }

	 /**
     * 查询
     */
    @RequestMapping("/query")
    public R query(FafangpaizhaoEntity fafangpaizhao){
        EntityWrapper< FafangpaizhaoEntity> ew = new EntityWrapper< FafangpaizhaoEntity>();
 		ew.allEq(MPUtil.allEQMapPre( fafangpaizhao, "fafangpaizhao")); 
		FafangpaizhaoView fafangpaizhaoView =  fafangpaizhaoService.selectView(ew);
		return R.ok("查询发放牌照成功").put("data", fafangpaizhaoView);
    }
	
    /**
     * 后端详情
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Long id){
        FafangpaizhaoEntity fafangpaizhao = fafangpaizhaoService.selectById(id);
        return R.ok().put("data", fafangpaizhao);
    }

    /**
     * 前端详情
     */
	@IgnoreAuth
    @RequestMapping("/detail/{id}")
    public R detail(@PathVariable("id") Long id){
        FafangpaizhaoEntity fafangpaizhao = fafangpaizhaoService.selectById(id);
        return R.ok().put("data", fafangpaizhao);
    }
    



    /**
     * 后端保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody FafangpaizhaoEntity fafangpaizhao, HttpServletRequest request){
    	//ValidatorUtils.validateEntity(fafangpaizhao);
        fafangpaizhaoService.insert(fafangpaizhao);
        return R.ok();
    }
    
    /**
     * 前端保存
     */
    @RequestMapping("/add")
    public R add(@RequestBody FafangpaizhaoEntity fafangpaizhao, HttpServletRequest request){
    	//ValidatorUtils.validateEntity(fafangpaizhao);
        fafangpaizhaoService.insert(fafangpaizhao);
        return R.ok();
    }





    /**
     * 修改
     */
    @RequestMapping("/update")
    @Transactional
    public R update(@RequestBody FafangpaizhaoEntity fafangpaizhao, HttpServletRequest request){
        //ValidatorUtils.validateEntity(fafangpaizhao);
        fafangpaizhaoService.updateById(fafangpaizhao);//全部更新
        return R.ok();
    }



    

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Long[] ids){
        fafangpaizhaoService.deleteBatchIds(Arrays.asList(ids));
        return R.ok();
    }
    
	










}
