package com.controller;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Date;
import java.util.List;
import javax.servlet.http.HttpServletRequest;

import com.utils.ValidatorUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.annotation.IgnoreAuth;

import com.entity.GongzuorenyuanEntity;
import com.entity.view.GongzuorenyuanView;

import com.service.GongzuorenyuanService;
import com.service.TokenService;
import com.utils.PageUtils;
import com.utils.R;
import com.utils.MPUtil;
import com.utils.MapUtils;
import com.utils.CommonUtil;
import java.io.IOException;

/**
 * 工作人员
 * 后端接口
 * @author 
 * @email 
 * @date 2030-03-20 23:07:14
 */
@RestController
@RequestMapping("/gongzuorenyuan")
public class GongzuorenyuanController {
    @Autowired
    private GongzuorenyuanService gongzuorenyuanService;




    
	@Autowired
	private TokenService tokenService;
	
	/**
	 * 登录
	 */
	@IgnoreAuth
	@RequestMapping(value = "/login")
	public R login(String username, String password, String captcha, HttpServletRequest request) {
		GongzuorenyuanEntity u = gongzuorenyuanService.selectOne(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", username));
		if(u==null || !u.getMima().equals(password)) {
			return R.error("账号或密码不正确");
		}
		
        if(!"是".equals(u.getSfsh())) return R.error("账号已锁定，请联系管理员审核。");
		String token = tokenService.generateToken(u.getId(), username,"gongzuorenyuan",  "工作人员" );
		return R.ok().put("token", token);
	}


	
	/**
     * 注册
     */
	@IgnoreAuth
    @RequestMapping("/register")
    public R register(@RequestBody GongzuorenyuanEntity gongzuorenyuan){
    	//ValidatorUtils.validateEntity(gongzuorenyuan);
    	GongzuorenyuanEntity u = gongzuorenyuanService.selectOne(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", gongzuorenyuan.getYuangongzhanghao()));
		if(u!=null) {
			return R.error("注册用户已存在");
		}
		Long uId = new Date().getTime();
		gongzuorenyuan.setId(uId);
        gongzuorenyuanService.insert(gongzuorenyuan);
        return R.ok();
    }

	
	/**
	 * 退出
	 */
	@RequestMapping("/logout")
	public R logout(HttpServletRequest request) {
		request.getSession().invalidate();
		return R.ok("退出成功");
	}
	
	/**
     * 获取用户的session用户信息
     */
    @RequestMapping("/session")
    public R getCurrUser(HttpServletRequest request){
    	Long id = (Long)request.getSession().getAttribute("userId");
        GongzuorenyuanEntity u = gongzuorenyuanService.selectById(id);
        return R.ok().put("data", u);
    }
    
    /**
     * 密码重置
     */
    @IgnoreAuth
	@RequestMapping(value = "/resetPass")
    public R resetPass(String username, HttpServletRequest request){
    	GongzuorenyuanEntity u = gongzuorenyuanService.selectOne(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", username));
    	if(u==null) {
    		return R.error("账号不存在");
    	}
        u.setMima("123456");
        gongzuorenyuanService.updateById(u);
        return R.ok("密码已重置为：123456");
    }



    /**
     * 后端列表
     */
    @RequestMapping("/page")
    public R page(@RequestParam Map<String, Object> params,GongzuorenyuanEntity gongzuorenyuan,
		HttpServletRequest request){
        EntityWrapper<GongzuorenyuanEntity> ew = new EntityWrapper<GongzuorenyuanEntity>();

		PageUtils page = gongzuorenyuanService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, gongzuorenyuan), params), params));

        return R.ok().put("data", page);
    }
    
    /**
     * 前端列表
     */
	@IgnoreAuth
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params,GongzuorenyuanEntity gongzuorenyuan, 
		HttpServletRequest request){
        EntityWrapper<GongzuorenyuanEntity> ew = new EntityWrapper<GongzuorenyuanEntity>();

		PageUtils page = gongzuorenyuanService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, gongzuorenyuan), params), params));
        return R.ok().put("data", page);
    }



	/**
     * 列表
     */
    @RequestMapping("/lists")
    public R list( GongzuorenyuanEntity gongzuorenyuan){
       	EntityWrapper<GongzuorenyuanEntity> ew = new EntityWrapper<GongzuorenyuanEntity>();
      	ew.allEq(MPUtil.allEQMapPre( gongzuorenyuan, "gongzuorenyuan")); 
        return R.ok().put("data", gongzuorenyuanService.selectListView(ew));
    }

	 /**
     * 查询
     */
    @RequestMapping("/query")
    public R query(GongzuorenyuanEntity gongzuorenyuan){
        EntityWrapper< GongzuorenyuanEntity> ew = new EntityWrapper< GongzuorenyuanEntity>();
 		ew.allEq(MPUtil.allEQMapPre( gongzuorenyuan, "gongzuorenyuan")); 
		GongzuorenyuanView gongzuorenyuanView =  gongzuorenyuanService.selectView(ew);
		return R.ok("查询工作人员成功").put("data", gongzuorenyuanView);
    }
	
    /**
     * 后端详情
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Long id){
        GongzuorenyuanEntity gongzuorenyuan = gongzuorenyuanService.selectById(id);
        return R.ok().put("data", gongzuorenyuan);
    }

    /**
     * 前端详情
     */
	@IgnoreAuth
    @RequestMapping("/detail/{id}")
    public R detail(@PathVariable("id") Long id){
        GongzuorenyuanEntity gongzuorenyuan = gongzuorenyuanService.selectById(id);
        return R.ok().put("data", gongzuorenyuan);
    }
    



    /**
     * 后端保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody GongzuorenyuanEntity gongzuorenyuan, HttpServletRequest request){
        if(gongzuorenyuanService.selectCount(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", gongzuorenyuan.getYuangongzhanghao()))>0) {
            return R.error("员工账号已存在");
        }
    	gongzuorenyuan.setId(new Date().getTime()+new Double(Math.floor(Math.random()*1000)).longValue());
    	//ValidatorUtils.validateEntity(gongzuorenyuan);
    	GongzuorenyuanEntity u = gongzuorenyuanService.selectOne(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", gongzuorenyuan.getYuangongzhanghao()));
		if(u!=null) {
			return R.error("用户已存在");
		}
		gongzuorenyuan.setId(new Date().getTime());
        gongzuorenyuanService.insert(gongzuorenyuan);
        return R.ok();
    }
    
    /**
     * 前端保存
     */
    @RequestMapping("/add")
    public R add(@RequestBody GongzuorenyuanEntity gongzuorenyuan, HttpServletRequest request){
        if(gongzuorenyuanService.selectCount(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", gongzuorenyuan.getYuangongzhanghao()))>0) {
            return R.error("员工账号已存在");
        }
    	gongzuorenyuan.setId(new Date().getTime()+new Double(Math.floor(Math.random()*1000)).longValue());
    	//ValidatorUtils.validateEntity(gongzuorenyuan);
    	GongzuorenyuanEntity u = gongzuorenyuanService.selectOne(new EntityWrapper<GongzuorenyuanEntity>().eq("yuangongzhanghao", gongzuorenyuan.getYuangongzhanghao()));
		if(u!=null) {
			return R.error("用户已存在");
		}
		gongzuorenyuan.setId(new Date().getTime());
        gongzuorenyuanService.insert(gongzuorenyuan);
        return R.ok();
    }





    /**
     * 修改
     */
    @RequestMapping("/update")
    @Transactional
    public R update(@RequestBody GongzuorenyuanEntity gongzuorenyuan, HttpServletRequest request){
        //ValidatorUtils.validateEntity(gongzuorenyuan);
        if(gongzuorenyuanService.selectCount(new EntityWrapper<GongzuorenyuanEntity>().ne("id", gongzuorenyuan.getId()).eq("yuangongzhanghao", gongzuorenyuan.getYuangongzhanghao()))>0) {
            return R.error("员工账号已存在");
        }
        gongzuorenyuanService.updateById(gongzuorenyuan);//全部更新
        return R.ok();
    }

    /**
     * 审核
     */
    @RequestMapping("/shBatch")
    @Transactional
    public R update(@RequestBody Long[] ids, @RequestParam String sfsh, @RequestParam String shhf){
        List<GongzuorenyuanEntity> list = new ArrayList<GongzuorenyuanEntity>();
        for(Long id : ids) {
            GongzuorenyuanEntity gongzuorenyuan = gongzuorenyuanService.selectById(id);
            gongzuorenyuan.setSfsh(sfsh);
            gongzuorenyuan.setShhf(shhf);
            list.add(gongzuorenyuan);
        }
        gongzuorenyuanService.updateBatchById(list);
        return R.ok();
    }


    

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Long[] ids){
        gongzuorenyuanService.deleteBatchIds(Arrays.asList(ids));
        return R.ok();
    }
    
	










}
