package com.controller;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Date;
import java.util.List;
import javax.servlet.http.HttpServletRequest;

import com.utils.ValidatorUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.annotation.IgnoreAuth;

import com.entity.JiashiyuanEntity;
import com.entity.view.JiashiyuanView;

import com.service.JiashiyuanService;
import com.service.TokenService;
import com.utils.PageUtils;
import com.utils.R;
import com.utils.MPUtil;
import com.utils.MapUtils;
import com.utils.CommonUtil;
import java.io.IOException;

/**
 * 驾驶员
 * 后端接口
 * @author 
 * @email 
 * @date 2030-03-20 23:07:14
 */
@RestController
@RequestMapping("/jiashiyuan")
public class JiashiyuanController {
    @Autowired
    private JiashiyuanService jiashiyuanService;




    
	@Autowired
	private TokenService tokenService;
	
	/**
	 * 登录
	 */
	@IgnoreAuth
	@RequestMapping(value = "/login")
	public R login(String username, String password, String captcha, HttpServletRequest request) {
		JiashiyuanEntity u = jiashiyuanService.selectOne(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", username));
		if(u==null || !u.getMima().equals(password)) {
			return R.error("账号或密码不正确");
		}
		
		String token = tokenService.generateToken(u.getId(), username,"jiashiyuan",  "驾驶员" );
		return R.ok().put("token", token);
	}


	
	/**
     * 注册
     */
	@IgnoreAuth
    @RequestMapping("/register")
    public R register(@RequestBody JiashiyuanEntity jiashiyuan){
    	//ValidatorUtils.validateEntity(jiashiyuan);
    	JiashiyuanEntity u = jiashiyuanService.selectOne(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", jiashiyuan.getZhanghao()));
		if(u!=null) {
			return R.error("注册用户已存在");
		}
		Long uId = new Date().getTime();
		jiashiyuan.setId(uId);
        jiashiyuanService.insert(jiashiyuan);
        return R.ok();
    }

	
	/**
	 * 退出
	 */
	@RequestMapping("/logout")
	public R logout(HttpServletRequest request) {
		request.getSession().invalidate();
		return R.ok("退出成功");
	}
	
	/**
     * 获取用户的session用户信息
     */
    @RequestMapping("/session")
    public R getCurrUser(HttpServletRequest request){
    	Long id = (Long)request.getSession().getAttribute("userId");
        JiashiyuanEntity u = jiashiyuanService.selectById(id);
        return R.ok().put("data", u);
    }
    
    /**
     * 密码重置
     */
    @IgnoreAuth
	@RequestMapping(value = "/resetPass")
    public R resetPass(String username, HttpServletRequest request){
    	JiashiyuanEntity u = jiashiyuanService.selectOne(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", username));
    	if(u==null) {
    		return R.error("账号不存在");
    	}
        u.setMima("123456");
        jiashiyuanService.updateById(u);
        return R.ok("密码已重置为：123456");
    }



    /**
     * 后端列表
     */
    @RequestMapping("/page")
    public R page(@RequestParam Map<String, Object> params,JiashiyuanEntity jiashiyuan,
		HttpServletRequest request){
        EntityWrapper<JiashiyuanEntity> ew = new EntityWrapper<JiashiyuanEntity>();

		PageUtils page = jiashiyuanService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, jiashiyuan), params), params));

        return R.ok().put("data", page);
    }
    
    /**
     * 前端列表
     */
	@IgnoreAuth
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params,JiashiyuanEntity jiashiyuan, 
		HttpServletRequest request){
        EntityWrapper<JiashiyuanEntity> ew = new EntityWrapper<JiashiyuanEntity>();

		PageUtils page = jiashiyuanService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, jiashiyuan), params), params));
        return R.ok().put("data", page);
    }



	/**
     * 列表
     */
    @RequestMapping("/lists")
    public R list( JiashiyuanEntity jiashiyuan){
       	EntityWrapper<JiashiyuanEntity> ew = new EntityWrapper<JiashiyuanEntity>();
      	ew.allEq(MPUtil.allEQMapPre( jiashiyuan, "jiashiyuan")); 
        return R.ok().put("data", jiashiyuanService.selectListView(ew));
    }

	 /**
     * 查询
     */
    @RequestMapping("/query")
    public R query(JiashiyuanEntity jiashiyuan){
        EntityWrapper< JiashiyuanEntity> ew = new EntityWrapper< JiashiyuanEntity>();
 		ew.allEq(MPUtil.allEQMapPre( jiashiyuan, "jiashiyuan")); 
		JiashiyuanView jiashiyuanView =  jiashiyuanService.selectView(ew);
		return R.ok("查询驾驶员成功").put("data", jiashiyuanView);
    }
	
    /**
     * 后端详情
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Long id){
        JiashiyuanEntity jiashiyuan = jiashiyuanService.selectById(id);
        return R.ok().put("data", jiashiyuan);
    }

    /**
     * 前端详情
     */
	@IgnoreAuth
    @RequestMapping("/detail/{id}")
    public R detail(@PathVariable("id") Long id){
        JiashiyuanEntity jiashiyuan = jiashiyuanService.selectById(id);
        return R.ok().put("data", jiashiyuan);
    }
    



    /**
     * 后端保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody JiashiyuanEntity jiashiyuan, HttpServletRequest request){
        if(jiashiyuanService.selectCount(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", jiashiyuan.getZhanghao()))>0) {
            return R.error("账号已存在");
        }
    	jiashiyuan.setId(new Date().getTime()+new Double(Math.floor(Math.random()*1000)).longValue());
    	//ValidatorUtils.validateEntity(jiashiyuan);
    	JiashiyuanEntity u = jiashiyuanService.selectOne(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", jiashiyuan.getZhanghao()));
		if(u!=null) {
			return R.error("用户已存在");
		}
		jiashiyuan.setId(new Date().getTime());
        jiashiyuanService.insert(jiashiyuan);
        return R.ok();
    }
    
    /**
     * 前端保存
     */
    @RequestMapping("/add")
    public R add(@RequestBody JiashiyuanEntity jiashiyuan, HttpServletRequest request){
        if(jiashiyuanService.selectCount(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", jiashiyuan.getZhanghao()))>0) {
            return R.error("账号已存在");
        }
    	jiashiyuan.setId(new Date().getTime()+new Double(Math.floor(Math.random()*1000)).longValue());
    	//ValidatorUtils.validateEntity(jiashiyuan);
    	JiashiyuanEntity u = jiashiyuanService.selectOne(new EntityWrapper<JiashiyuanEntity>().eq("zhanghao", jiashiyuan.getZhanghao()));
		if(u!=null) {
			return R.error("用户已存在");
		}
		jiashiyuan.setId(new Date().getTime());
        jiashiyuanService.insert(jiashiyuan);
        return R.ok();
    }





    /**
     * 修改
     */
    @RequestMapping("/update")
    @Transactional
    public R update(@RequestBody JiashiyuanEntity jiashiyuan, HttpServletRequest request){
        //ValidatorUtils.validateEntity(jiashiyuan);
        if(jiashiyuanService.selectCount(new EntityWrapper<JiashiyuanEntity>().ne("id", jiashiyuan.getId()).eq("zhanghao", jiashiyuan.getZhanghao()))>0) {
            return R.error("账号已存在");
        }
        jiashiyuanService.updateById(jiashiyuan);//全部更新
        return R.ok();
    }



    

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Long[] ids){
        jiashiyuanService.deleteBatchIds(Arrays.asList(ids));
        return R.ok();
    }
    
	










}
