package com.controller;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Date;
import java.util.List;
import javax.servlet.http.HttpServletRequest;

import com.utils.ValidatorUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.mapper.Wrapper;
import com.annotation.IgnoreAuth;

import com.entity.ShigujiluEntity;
import com.entity.view.ShigujiluView;

import com.service.ShigujiluService;
import com.service.TokenService;
import com.utils.PageUtils;
import com.utils.R;
import com.utils.MPUtil;
import com.utils.MapUtils;
import com.utils.CommonUtil;
import java.io.IOException;

/**
 * 事故记录
 * 后端接口
 * @author 
 * @email 
 * @date 2030-03-20 23:07:14
 */
@RestController
@RequestMapping("/shigujilu")
public class ShigujiluController {
    @Autowired
    private ShigujiluService shigujiluService;




    



    /**
     * 后端列表
     */
    @RequestMapping("/page")
    public R page(@RequestParam Map<String, Object> params,ShigujiluEntity shigujilu,
		HttpServletRequest request){
		String tableName = request.getSession().getAttribute("tableName").toString();
		if(tableName.equals("jiashiyuan")) {
			shigujilu.setZhanghao((String)request.getSession().getAttribute("username"));
		}
		if(tableName.equals("gongzuorenyuan")) {
			shigujilu.setYuangongzhanghao((String)request.getSession().getAttribute("username"));
		}
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();

		PageUtils page = shigujiluService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, shigujilu), params), params));

        return R.ok().put("data", page);
    }
    
    /**
     * 前端列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params,ShigujiluEntity shigujilu, 
		HttpServletRequest request){
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();

		PageUtils page = shigujiluService.queryPage(params, MPUtil.sort(MPUtil.between(MPUtil.likeOrEq(ew, shigujilu), params), params));
        return R.ok().put("data", page);
    }



	/**
     * 列表
     */
    @RequestMapping("/lists")
    public R list( ShigujiluEntity shigujilu){
       	EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();
      	ew.allEq(MPUtil.allEQMapPre( shigujilu, "shigujilu")); 
        return R.ok().put("data", shigujiluService.selectListView(ew));
    }

	 /**
     * 查询
     */
    @RequestMapping("/query")
    public R query(ShigujiluEntity shigujilu){
        EntityWrapper< ShigujiluEntity> ew = new EntityWrapper< ShigujiluEntity>();
 		ew.allEq(MPUtil.allEQMapPre( shigujilu, "shigujilu")); 
		ShigujiluView shigujiluView =  shigujiluService.selectView(ew);
		return R.ok("查询事故记录成功").put("data", shigujiluView);
    }
	
    /**
     * 后端详情
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Long id){
        ShigujiluEntity shigujilu = shigujiluService.selectById(id);
        return R.ok().put("data", shigujilu);
    }

    /**
     * 前端详情
     */
    @RequestMapping("/detail/{id}")
    public R detail(@PathVariable("id") Long id){
        ShigujiluEntity shigujilu = shigujiluService.selectById(id);
        return R.ok().put("data", shigujilu);
    }
    



    /**
     * 后端保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody ShigujiluEntity shigujilu, HttpServletRequest request){
        if(shigujiluService.selectCount(new EntityWrapper<ShigujiluEntity>().eq("fadongjihao", shigujilu.getFadongjihao()))>0) {
            return R.error("发动机号已存在");
        }
        if(shigujiluService.selectCount(new EntityWrapper<ShigujiluEntity>().eq("chejiahao", shigujilu.getChejiahao()))>0) {
            return R.error("车架号已存在");
        }
    	//ValidatorUtils.validateEntity(shigujilu);
        shigujiluService.insert(shigujilu);
        return R.ok();
    }
    
    /**
     * 前端保存
     */
    @RequestMapping("/add")
    public R add(@RequestBody ShigujiluEntity shigujilu, HttpServletRequest request){
        if(shigujiluService.selectCount(new EntityWrapper<ShigujiluEntity>().eq("fadongjihao", shigujilu.getFadongjihao()))>0) {
            return R.error("发动机号已存在");
        }
        if(shigujiluService.selectCount(new EntityWrapper<ShigujiluEntity>().eq("chejiahao", shigujilu.getChejiahao()))>0) {
            return R.error("车架号已存在");
        }
    	//ValidatorUtils.validateEntity(shigujilu);
        shigujiluService.insert(shigujilu);
        return R.ok();
    }





    /**
     * 修改
     */
    @RequestMapping("/update")
    @Transactional
    public R update(@RequestBody ShigujiluEntity shigujilu, HttpServletRequest request){
        //ValidatorUtils.validateEntity(shigujilu);
        if(shigujiluService.selectCount(new EntityWrapper<ShigujiluEntity>().ne("id", shigujilu.getId()).eq("fadongjihao", shigujilu.getFadongjihao()))>0) {
            return R.error("发动机号已存在");
        }
        if(shigujiluService.selectCount(new EntityWrapper<ShigujiluEntity>().ne("id", shigujilu.getId()).eq("chejiahao", shigujilu.getChejiahao()))>0) {
            return R.error("车架号已存在");
        }
        shigujiluService.updateById(shigujilu);//全部更新
        return R.ok();
    }



    

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Long[] ids){
        shigujiluService.deleteBatchIds(Arrays.asList(ids));
        return R.ok();
    }
    
	






    /**
     * （按值统计）
     */
    @RequestMapping("/value/{xColumnName}/{yColumnName}")
    public R value(@PathVariable("yColumnName") String yColumnName, @PathVariable("xColumnName") String xColumnName,HttpServletRequest request) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("xColumn", xColumnName);
        params.put("yColumn", yColumnName);
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();
		String tableName = request.getSession().getAttribute("tableName").toString();
		if(tableName.equals("jiashiyuan")) {
            ew.eq("zhanghao", (String)request.getSession().getAttribute("username"));
		}
		if(tableName.equals("gongzuorenyuan")) {
            ew.eq("yuangongzhanghao", (String)request.getSession().getAttribute("username"));
		}
        List<Map<String, Object>> result = shigujiluService.selectValue(params, ew);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        for(Map<String, Object> m : result) {
            for(String k : m.keySet()) {
                if(m.get(k) instanceof Date) {
                    m.put(k, sdf.format((Date)m.get(k)));
                }
            }
        }
        return R.ok().put("data", result);
    }

    /**
     * （按值统计(多)）
     */
    @RequestMapping("/valueMul/{xColumnName}")
    public R valueMul(@PathVariable("xColumnName") String xColumnName,@RequestParam String yColumnNameMul, HttpServletRequest request) {
        String[] yColumnNames = yColumnNameMul.split(",");
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("xColumn", xColumnName);
        List<List<Map<String, Object>>> result2 = new ArrayList<List<Map<String,Object>>>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();
        String tableName = request.getSession().getAttribute("tableName").toString();
        if(tableName.equals("jiashiyuan")) {
            ew.eq("zhanghao", (String)request.getSession().getAttribute("username"));
        }
        if(tableName.equals("gongzuorenyuan")) {
            ew.eq("yuangongzhanghao", (String)request.getSession().getAttribute("username"));
        }
        for(int i=0;i<yColumnNames.length;i++) {
            params.put("yColumn", yColumnNames[i]);
            List<Map<String, Object>> result = shigujiluService.selectValue(params, ew);
            for(Map<String, Object> m : result) {
                for(String k : m.keySet()) {
                    if(m.get(k) instanceof Date) {
                        m.put(k, sdf.format((Date)m.get(k)));
                    }
                }
            }
            result2.add(result);
        }
        return R.ok().put("data", result2);
    }

    /**
     * （按值统计）时间统计类型
     */
    @RequestMapping("/value/{xColumnName}/{yColumnName}/{timeStatType}")
    public R valueDay(@PathVariable("yColumnName") String yColumnName, @PathVariable("xColumnName") String xColumnName, @PathVariable("timeStatType") String timeStatType,HttpServletRequest request) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("xColumn", xColumnName);
        params.put("yColumn", yColumnName);
        params.put("timeStatType", timeStatType);
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();
        String tableName = request.getSession().getAttribute("tableName").toString();
        if(tableName.equals("jiashiyuan")) {
            ew.eq("zhanghao", (String)request.getSession().getAttribute("username"));
        }
        if(tableName.equals("gongzuorenyuan")) {
            ew.eq("yuangongzhanghao", (String)request.getSession().getAttribute("username"));
        }
        List<Map<String, Object>> result = shigujiluService.selectTimeStatValue(params, ew);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        for(Map<String, Object> m : result) {
            for(String k : m.keySet()) {
                if(m.get(k) instanceof Date) {
                    m.put(k, sdf.format((Date)m.get(k)));
                }
            }
        }
        return R.ok().put("data", result);
    }

    /**
     * （按值统计）时间统计类型(多)
     */
    @RequestMapping("/valueMul/{xColumnName}/{timeStatType}")
    public R valueMulDay(@PathVariable("xColumnName") String xColumnName, @PathVariable("timeStatType") String timeStatType,@RequestParam String yColumnNameMul,HttpServletRequest request) {
        String[] yColumnNames = yColumnNameMul.split(",");
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("xColumn", xColumnName);
        params.put("timeStatType", timeStatType);
        List<List<Map<String, Object>>> result2 = new ArrayList<List<Map<String,Object>>>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();
        String tableName = request.getSession().getAttribute("tableName").toString();
        if(tableName.equals("jiashiyuan")) {
            ew.eq("zhanghao", (String)request.getSession().getAttribute("username"));
        }
        if(tableName.equals("gongzuorenyuan")) {
            ew.eq("yuangongzhanghao", (String)request.getSession().getAttribute("username"));
        }
        for(int i=0;i<yColumnNames.length;i++) {
            params.put("yColumn", yColumnNames[i]);
            List<Map<String, Object>> result = shigujiluService.selectTimeStatValue(params, ew);
            for(Map<String, Object> m : result) {
                for(String k : m.keySet()) {
                    if(m.get(k) instanceof Date) {
                        m.put(k, sdf.format((Date)m.get(k)));
                    }
                }
            }
            result2.add(result);
        }
        return R.ok().put("data", result2);
    }

    /**
     * 分组统计
     */
    @RequestMapping("/group/{columnName}")
    public R group(@PathVariable("columnName") String columnName,HttpServletRequest request) {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("column", columnName);
        EntityWrapper<ShigujiluEntity> ew = new EntityWrapper<ShigujiluEntity>();
        String tableName = request.getSession().getAttribute("tableName").toString();
        if(tableName.equals("jiashiyuan")) {
            ew.eq("zhanghao", (String)request.getSession().getAttribute("username"));
        }
        if(tableName.equals("gongzuorenyuan")) {
            ew.eq("yuangongzhanghao", (String)request.getSession().getAttribute("username"));
        }
        List<Map<String, Object>> result = shigujiluService.selectGroup(params, ew);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        for(Map<String, Object> m : result) {
            for(String k : m.keySet()) {
                if(m.get(k) instanceof Date) {
                    m.put(k, sdf.format((Date)m.get(k)));
                }
            }
        }
        return R.ok().put("data", result);
    }







}
